import {Component, EventEmitter, inject, Input, Output} from '@angular/core';
import {Show} from '../../model/show';
import {FormsModule} from '@angular/forms';
import {ShowService} from '../../services/show.service';
import {Observable} from 'rxjs';
import {AsyncPipe} from '@angular/common';

@Component({
  selector: 'app-show-list',
  standalone: true,
  imports: [
    FormsModule,
    AsyncPipe
  ],
  templateUrl: './show-list.component.html',
  styleUrl: './show-list.component.css'
})
export class ShowListComponent {
  showService: ShowService = inject(ShowService);
  shows: Observable<Show[]> = this.showService.getShows();

  @Output() selectedShow = new EventEmitter<Show>();
  editShow: Show = new Show(0, "");

  showDetails(show: Show) {
    this.selectedShow.emit(show);
  }

  edit(show: Show) {
    this.editShow = show;
  }

  saveEdit() {
    this.updateShow(this.editShow);

    this.editShow = new Show(0, "");
  }

  updateShow(show: Show) {
    // this.shows = this.shows.filter(s => s !== show);
    // this.shows.push(show);
    // this.shows.sort((a, b) => (a.uid ?? 0) - (b.uid ?? 0));
  }

  delete(show: Show) {
    // this.shows = this.shows.filter(s => s !== show);
  }

  isToEdit(show: Show): boolean {
    if (!this.editShow) {
      return false;
    } else {
      return this.editShow === show;
    }
  }
}
